### Data management
* **Conversion**: To import a tabulated file containing quantitative data and convert it into an MSnset structure.
* **Loading**: To open an Msnset structure that has been previously constructed.
* **Exporting**: To save a partially/completely processed dataset and to download the data analysis results.
* **Demo data**: Toy datasets are available to discover Prostar potential in the simplest way.

### Data processing
* **Filtering**: To prune the protein or peptide list according to various criteria (missing values, string matching).
* **Normalization**: To correct batch or group effects.
* **Imputation**: By taking into account the very nature of each missing value.
* **Aggregation**: For peptide-level datasets, it is possible to estimate protein abundances.
* **Hypothesis testing**: To compute the significance of each protein differential abundance.

### Data mining
* **Descriptive statistics**: Available at any stage of the analysis, for data exploration and visualization.
* **Peptide-Protein Graph**: Explore and visualize peptide-protein graphs.
* **Differential analysis**: To select a list of differentially abundant proteins with a controlled false discovery rate.
* **Gene Ontology analysis**: To  map a protein list onto GO terms and test category enrichment.
